<template>
  <section class="relative">
    <div>
      <img src="/contact_bg.webp" class="object-cover w-full h-full" loading="lazy" alt="Imagen de fondo sección de contacto"></img>
    </div>

    <div class="container w-full px-10 mx-auto lg:w-11/12 lg:border glass bg-secondary/80 border-primary rounded-2xl lg:py-20 md:w-2/3 xl:w-1/2 lg:absolute lg:left-1/2 lg:top-1/2 lg:transform lg:-translate-x-1/2 lg:-translate-y-1/2 lg:px-28">
      <h3 class="mt-10 section-title text-primary lg:mt-0">
        {{ $t('contact.form.title') }}
      </h3>

      <form @submit.prevent="sendForm()" class="grid grid-cols-1 gap-y-6 gap-x-4 sm:grid-cols-6">
        <div class="sm:col-span-3">
          <input type="text" v-model="formData.firstname" name="firstname" id="firstname" :placeholder="$t('contact.form.fields.name')" autocomplete="given-name" class="input" required>
        </div>

        <div class="sm:col-span-3">
          <input type="text" v-model="formData.lastname" name="lastname" id="lastname" :placeholder="$t('contact.form.fields.lastname')" autocomplete="given-lastname" class="input" required>
        </div>

        <div class="sm:col-span-3">
          <input type="email" v-model="formData.email" name="email" id="email" :placeholder="$t('contact.form.fields.email')" autocomplete="given-email" class="input" required>
        </div>

        <div class="sm:col-span-3">
          <input type="tel" v-model="formData.phone" name="phone" id="phone" :placeholder="$t('contact.form.fields.phone')" autocomplete="given-phone" class="input" required>
        </div>

        <div class="sm:col-span-6">
          <textarea v-model="formData.message" name="message" id="message" :placeholder="$t('contact.form.fields.message')" class="block w-full h-32 text-white bg-transparent rounded-md shadow-sm focus:ring-primary focus:border-primary sm:text-sm border-muted placeholder-muted"></textarea>
        </div>

        <div class="flex items-center sm:col-span-6" :class="[{'justify-between': formMessage}, {'justify-end': !formMessage}]">
          <p class="text-white">{{ formMessage }}</p>
          <button class="w-full btn btn-primary lg:w-auto" :class="[{'opacity-75 pointer-events-none': formMessage}]">
            <span v-if="!sendingForm">{{ $t('contact.form.button') }}</span>
            <svg v-else class="w-5 h-5 text-black animate-spin" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24">
              <circle class="opacity-25" cx="12" cy="12" r="10" stroke="currentColor" stroke-width="4"></circle>
              <path class="opacity-75" fill="currentColor" d="M4 12a8 8 0 018-8V0C5.373 0 0 5.373 0 12h4zm2 5.291A7.962 7.962 0 014 12H0c0 3.042 1.135 5.824 3 7.938l3-2.647z"></path>
            </svg>
          </button>
        </div>
      </form>
    </div>
  </section>
</template>

<script>
export default {
  name: 'ContactSection',

  data() {
    return {
      formData: {
        firstname: null,
        lastname: null,
        email: null,
        phone: null,
        message: null,
      },
      formMessage: null,
      sendingForm: false
    }
  },

  methods: {
    sendForm() {
      this.sendingForm = true
      fetch('/api/contact', {
        method: 'POST',
        body: JSON.stringify(this.formData),
        headers: { 'Content-type': 'application/json; charset=UTF-8' },
      })
        .then((response) => response.json())
        .then((res) => {
          // eslint-disable-next-line no-console
          console.log(res)
          if(res.result === 'success') {
            this.formMessage = this.$t('contact.form.messages.success')
          }
          this.sendingForm = false
        })
        .catch((err) => {
          // eslint-disable-next-line no-console
          console.error(err, 'error')
          this.formMessage = this.$t('contact.form.messages.error')
          this.sendingForm = false

        })
    },
  }
}
</script>

<style></style>